<?php



/* DS: Rewrite with bcmath for 32bit system compatibility */
class MSTICKS extends NULLReaderTime implements READERTimeInterface {
 var $correction;

 const START = 621355968000000000;
    
 function __construct(READER $reader = NULL, $correction = 0) {
    parent::__construct($reader);

    if (is_int($correction)) $this->correction = $correction;
    else $this->correction = 0;
 }
    
 function ImportTime(DateTime $dt) {
    return floor(10000000*$dt->format("U.u")) + MSTICKS::START - $this->correction;
 }
    
 function ExportTime($db_time) {
    global $adei_profiler;

    $ticks = ($db_time - MSTICKS::START + $this->correction);

    $ns100 = $ticks % 10000000;
    $timestamp =  ($ticks - $ns100) / 10000000;
	
    if ($ns100) {
	$len = strlen($ns100);
	if ($len < 7) $ns100 = str_repeat('0', 7 - $len) . $ns100;

        return new DateTime(strftime("%Y/%m/%d %H:%M:%S", $timestamp) . ".$ns100", $this->gmt_timezone);
    } else {
	return new DateTime("@$timestamp", $this->gmt_timezone);
    }
 }
 
 function GetTimeSlicingFunction($db_time_var, $width, $offset = 0) {
    if ($offset) {
	if (is_object($offset)) 
	    $off = $this->ImportTime($offset);
	else
	    $off = $this->ImportUnixTime($offset);

	return "($db_time_var - $off) / " . (10000000 * $width);
    } 
    
    return "$db_time_var / " . (10000000 * $width);
 }
}

?>