<?php
require("../adei.php");

$_POST['props'] = "{\"db_server\": \"labview\", \"db_name\": \"womisaDB\", \"db_group\": \"g006\", \"db_mask\": \"1\", \"experiment\": \"0-0\", \"window\": \"1200447001.2968366-1200447001.297248\", \"width\": 864, \"height\": 616}";

$req = new DATARequest();

if (isset($req->props['filename'])) $name = $req->props['filename'];
else {
    // DS: common naming
}


header("Content-type: application/binary"); 
header("Content-Disposition: attachment; filename=\"" . $name . "\"");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");


try {
    $reader = $req->CreateReader();
    $grp = $reader->CreateGroup();
    
    switch ($req->props['format']) {
	case "root":
	case "root_hist":
	    $tmpf = tempnam(sys_get_temp_dir(), "csv2root_");
	    
	    $opts = "--overwrite --file $tmpf";
	    if ($req->props['format'] == "root_hist") $opts .= " --save-histograms";
	    if ((!isset($ROOT_COMBIHIST_LIMIT))||(($req->props["interval_end"] - $req->props["interval_start"]) < $ROOT_COMBIHIST_LIMIT)) $opts .= " --combined-histogram";

	    $cmd = popen(adei_app("csv2root", $opts, true), "w");
	    if (!$cmd) throw new ADEIException("csv2root is not present");
	    $reader->ExportCSV(new DATAStreamHandler($cmd), $grp, $req->props["interval_start"], $req->props["interval_end"]);
	    
	    if ($err = pclose($cmd)) {
		@unlink($tmpf);
		throw new ADEIException("csv2root is finished with error: $err");
	    }

	    readfile($tmpf);
	    unlink($tmpf);
	break;
	default:
	    $reader->ExportCSV(new DATAStreamHandler(), $grp, $req->props["interval_start"], $req->props["interval_end"]);
    }
} catch(ADEIException $e) {
    echo "ERROR: " . $e->getMessage();
}

?>